<?php
// +---------------------------------------------------------------------------+
// | Chameleon Plugin                                                          |
// +---------------------------------------------------------------------------+
// | $Id::                                                                    $|
// | Development Code Upgrade routine -                                        |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2007 by the following authors:                              |
// |                                                                           |
// | Author: mevans@ecsnet.com                                                 |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//
require_once('../../../lib-common.php');

// Only let admin users access this page
if (!SEC_inGroup('Root')) {
    // Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access the Chameleon Development Code Upgrade Routine.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
    $display  = COM_siteHeader();
    $display .= COM_startBlock($LANG_CN00['access_denied']);
    $display .= $LANG_CN00['access_denied_msg'];
    $display .= COM_endBlock();
    $display .= COM_siteFooter(true);
    echo $display;
    exit;
}

COM_errorLog("Chameleon: Running development code update for Media Gallery v1.5.1svn");

$retval .= 'Performing database upgrades if necessary...<br>';

$_SQL = array();
$_SQL[] = "ALTER TABLE {$_TABLES['cn_settings']} ADD `slogan` TINYINT(4) NOT NULL DEFAULT '1' AFTER `logo`";
$_SQL[] = "ALTER TABLE {$_TABLES['cn_settings']} ADD `menualign` TINYINT(4) NOT NULL DEFAULT '1' AFTER `menu`";
$_SQL[] = "UPDATE {$_TABLES['cn_settings']} SET menu=18";
$_SQL[] = "UPDATE {$_TABLES['cn_settings']} SET layout=1,color=36,lblock=30,rblock=33,menu=18,menualign=1,logo=1,slogan=1";
$_SQL[] = "DELETE FROM {$_TABLES['cn_styles']} WHERE id > 0 AND id < 44";
$_SQL[] = "INSERT INTO {$_TABLES['cn_styles']} (`id`, `type`, `name`, `description`) VALUES " .
            "(1, 'layout', 'Layout 1', 'Fluid center content column with fixed navigation and extra columns')," .
            "(2, 'layout', 'Layout 2', 'Fluid content on left with navigation and extra columns on the right')," .
            "(3, 'layout', 'Layout 3', 'Fluid content on right with navigation and extra columns on the left')," .
            "(4, 'layout', 'Layout 4', 'Navigation and Extra columns are stacked and floated right of the content')," .
            "(5, 'layout', 'Layout 5', 'Navigation and Extra columns are stacked and floated left of the content')," .
            "(6, 'layout', 'Layout 6', 'Fixed navigation on right with fluid content and fluid extras below both')," .
            "(7, 'layout', 'Layout 7', 'Fixed navigation on left with fluid content and fluid extras below both')," .
            "(8, 'layout', 'Layout 8', 'Fixed center content column with fixed navigation and extra columns ')," .
            "(9, 'layout', 'Layout 9', 'Fixed content column with fixed navigation and extra columns floated right')," .
            "(10, 'layout', 'Layout 10', 'Fixed content column with fixed navigation and extra columns floated left')," .
            "(11, 'layout', 'Layout 11', 'Fixed content column with fixed navigation and extra columns stacked right')," .
            "(12, 'layout', 'Layout 12', 'Fixed content column with fixed navigation and extra columns stacked left')," .
            "(13, 'layout', 'Layout 13', 'Fixed content column with fixed extra below and navigation floated right ')," .
            "(14, 'layout', 'Layout 14', 'Fixed content column with fixed extra below and navigation floated left')," .
            "(15, 'layout', 'Layout 15', 'Fixed content column with navigation floated right with extras below both')," .
            "(16, 'layout', 'Layout 16', 'Fixed content column with navigation floated left with extras below both')," .
            "(17, 'layout', 'Layout 17', 'Fixed content column with navigation and extra columns below')," .
            "(18, 'menu', 'Menu 1', 'Silver Buttons')," .
            "(19, 'menu', 'Menu 2', 'Grey with slanted dividers')," .
            "(20, 'menu', 'Menu 3', 'Silver bg with black highlight and bottom divider bar')," .
            "(21, 'menu', 'Menu 4', 'Thin menu with hover')," .
            "(22, 'menu', 'Menu 5', 'Blue Buttons with black highlight')," .
            "(23, 'menu', 'Menu 6', 'Black bar with blue underline highlight')," .
            "(24, 'menu', 'Menu 7', 'Black glass tabs on dark background')," .
            "(25, 'menu', 'Menu 8', 'Dark menu with rounded retro highlight')," .
            "(26, 'menu', 'Menu 9', 'Smooth blue tabs on black background')," .
            "(27, 'menu', 'Menu 10', 'Blue glass tabs with a border')," .
            "(28, 'menu', 'Menu 11', 'Large fixed-size block with rounded hover')," .
            "(29, 'menu', 'Menu 12', 'Transparent button background with alpha shaded highlight')," .
            "(30, 'lblock', 'Shaded Title BG', 'Block with shaded title background')," .
            "(31, 'lblock', 'No Title Shading', 'Block with bold title - no title background shading')," .
            "(32, 'lblock', 'No Title', 'No block title at all')," .
            "(33, 'rblock', 'Shaded Title BG', 'Block with shaded title background')," .
            "(34, 'rblock', 'No Title Shading', 'Block with bold title - no title background shading')," .
            "(35, 'rblock', 'No Title', 'No block title at all')," .
            "(36, 'color', 'Light Blue', 'Light blue color scheme')," .
            "(37, 'color', 'Dark Blue', 'Dark blue color scheme')," .
            "(38, 'color', 'Light Green', 'Light Green Theme')," .
            "(39, 'color', 'Dark Green', 'Dark Green Theme')," .
            "(40, 'color', 'Light Purple', 'Light purple color style')," .
            "(41, 'color', 'Dark Purple', 'Dark purple color style')," .
            "(42, 'color', 'Light Red', 'Light red color style')," .
            "(43, 'color', 'Dark Red', 'Dark red color scheme');";


/* Execute SQL now to perform the upgrade */
for ($i = 1; $i <= count($_SQL); $i++) {
    COM_errorLOG("Chameleon Development update: Executing SQL => " . current($_SQL));
    DB_query(current($_SQL),1);
    next($_SQL);
}
DB_query("UPDATE {$_TABLES['plugins']} SET pi_homepage='http://www.gllabs.org' WHERE pi_name='chameleon'",1);
DB_query("UPDATE {$_TABLES['plugins']} SET pi_version='" . $_CN_CONF['version'] . "' WHERE pi_name='chameleon' LIMIT 1");

$retval .= 'Development Code upgrades complete - see error.log for details<br>';

$display = COM_siteHeader();
$display .= $retval;
$display .= COM_siteFooter();
echo $display;
exit;
?>