<?php
// +---------------------------------------------------------------------------+
// | Chameleon                                                                 |
// +---------------------------------------------------------------------------+
// | $Id:: index.php 18 2007-11-17 07:00:33Z mark                             $|
// | Set configuration options for Chameleon Plugin.                           |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2007 by the following authors:                              |
// |                                                                           |
// | Author: mevans@ecsnet.com                                                 |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

require_once('../../../lib-common.php');

if (!SEC_inGroup('Root')) {
    // Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access the Chameleon install/uninstall page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
    $display = COM_siteHeader();
    $display .= COM_startBlock($LANG_CN00['access_denied']);
    $display .= $LANG_CN00['access_denied_msg'];
    $display .= COM_endBlock();
    $display .= COM_siteFooter(true);
    echo $display;
    exit;
}

function CN_editSettings( ) {
    global $_CONF, $_CN_CONF, $_TABLES, $_USER, $LANG_CN00, $LANG_CN01, $LANG_DIRECTION,$LANG04;

    $retval = '';
    $T = new Template($_CONF['path'] . 'plugins/chameleon/templates');
    $T->set_file ('admin','settings.thtml');
    $T->set_var('site_url', $_CONF['site_url']);
    $T->set_var('site_admin_url', $_CONF['site_admin_url']);
    $T->set_var('layout_url', $_CONF['layout_url']);
    $T->set_var('xhtml',XHTML);

    include_once($_CONF['path_system']."classes/navbar.class.php");
    $navbar = new navbar;
    $navbar->add_menuitem($LANG_CN01['page_layout'],'showhideCNsettingDiv("layout",0);return false;',true);
    $navbar->add_menuitem($LANG_CN01['menu_style'],'showhideCNsettingDiv("menu",1);return false;',true);
    $navbar->add_menuitem($LANG_CN01['block_style'],'showhideCNsettingDiv("leftblocks",2);return false;',true);
    $navbar->add_menuitem($LANG_CN01['color_scheme'],'showhideCNsettingDiv("color",3);return false;',true);
    $navbar->add_menuitem($LANG_CN01['logo'],'showhideCNsettingDiv("logo",4);return false;',true);
    $navbar->add_menuitem($LANG_CN01['addstyle'],'showhideCNsettingDiv("add",5);return false;',true);

    $navbar->set_selected($LANG_CN01['page_layout']);
    $T->set_var ('navbar', $navbar->generate());

    $T->set_var(array(
        's_form_action'             => $_CONF['site_admin_url'] . '/plugins/chameleon/index.php',
        'no_javascript_warning'     => $LANG04[150],
        'lang_yes'                  => $LANG_CN01['yes'],
        'lang_no'                   => $LANG_CN01['no'],
        'lang_save'                 => $LANG_CN01['save'],
        'lang_cancel'               => $LANG_CN01['cancel'],
        'lang_reset'                => $LANG_CN01['reset'],
        'lang_settings'             => $LANG_CN01['settings'],
        'lang_layout_options'       => $LANG_CN01['layout_options'],
        'lang_id'                   => $LANG_CN01['id'],
        'lang_color_options'        => $LANG_CN01['color_options'],
        'lang_left_block_options'   => $LANG_CN01['left_block_options'],
        'lang_right_block_options'  => $LANG_CN01['right_block_options'],
        'lang_menu_options'         => $LANG_CN01['menu_options'],
        'lang_logo_options'         => $LANG_CN01['logo_options'],
        'lang_add_style_pack'       => $LANG_CN01['add_style_pack'],
        'lang_style_type'           => $LANG_CN01['style_type'],
        'lang_layout'               => $LANG_CN01['layout'],
        'lang_color'                => $LANG_CN01['color'],
        'lang_menu'                 => $LANG_CN01['menu'],
        'lang_lblock'               => $LANG_CN01['left_block'],
        'lang_rblock'               => $LANG_CN01['right_block'],
        'lang_name'                 => $LANG_CN01['name'],
        'lang_description'          => $LANG_CN01['description'],
        'lang_style_pack'           => $LANG_CN01['style_pack_zip'],
        'lang_manual_entry'         => $LANG_CN01['manual_entry'],
        'lang_zip_entry'            => $LANG_CN01['zip_entry'],
        'lang_edit'                 => $LANG_CN01['edit'],
        'lang_delete_confirm'       => $LANG_CN01['delete_confirm'],
        'lang_delete'               => $LANG_CN01['delete'],
        'lang_use_graphic_logo'     => $LANG_CN01['use_graphic_logo'],
        'lang_use_text_logo'        => $LANG_CN01['use_text_logo'],
        'lang_display_site_slogan'  => $LANG_CN01['display_site_slogan'],
        'lang_upload_logo'          => $LANG_CN01['upload_logo'],
        'lang_logo_help'            => $LANG_CN01['logo_help'],
    ));

    $current_theme_layout = DB_getItem($_TABLES['cn_settings'],'layout');
    $result = DB_query("SELECT * FROM {$_TABLES['cn_styles']} WHERE type='layout'");
    $nRows  = DB_numRows($result);

    $T->set_block('admin', 'layout','tlayout');

    for ( $i=0; $i < $nRows; $i++ ) {
        $row = DB_fetchArray($result);
        if ( !file_exists($_CONF['path_themes'] . '/chameleon/styles/layout/' . $row['id'] . '/layout.css') ) {
            continue;
        }

        $T->set_var(array(
            'thumbnail'     =>  "<img src=\"{$_CONF['site_url']}/layout/chameleon/styles/layout/{$row['id']}/layout.gif\" alt=\"{$row['description']}\" title=\"{$row['description']}\" style=\"border:1px solid #CCCCCC;\"" . XHTML . ">",
            'selected'      =>  ($current_theme_layout == $row['id'] ? ' checked="checked"' : '' ),
            'id'            =>  $row['id'],
            'name'          =>  $row['name'],
            'description'   =>  $row['description']
        ));
        $T->parse('tlayout','layout',true);
    }

    $current_color = DB_getItem($_TABLES['cn_settings'],'color');
    $result = DB_query("SELECT * FROM {$_TABLES['cn_styles']} WHERE type='color'");
    $nRows  = DB_numRows($result);

    $T->set_block('admin', 'color','tcolor');

    for ( $i=0; $i < $nRows; $i++ ) {
        $row = DB_fetchArray($result);
        $T->set_var(array(
            'thumbnail'     =>  "<img src=\"{$_CONF['site_url']}/layout/chameleon/styles/color/{$row['id']}/color.gif\" alt=\"{$row['description']}\" title=\"{$row['description']}\" style=\"border:1px solid #CCCCCC;\"" . XHTML . ">",
            'selected'      =>  ($current_color == $row['id'] ? ' checked="checked"' : '' ),
            'id'            =>  $row['id'],
            'name'          =>  $row['name'],
            'description'   =>  $row['description']
        ));
        $T->parse('tcolor','color',true);
    }

    $current_lblock = DB_getItem($_TABLES['cn_settings'],'lblock');
    $result = DB_query("SELECT * FROM {$_TABLES['cn_styles']} WHERE type='lblock'");
    $nRows  = DB_numRows($result);

    $T->set_block('admin', 'lblock','ltblock');

    for ( $i=0; $i < $nRows; $i++ ) {
        $row = DB_fetchArray($result);
        $T->set_var(array(
            'thumbnail'     =>  "<img src=\"{$_CONF['site_url']}/layout/chameleon/styles/lblock/{$row['id']}/block.gif\" alt=\"{$row['description']}\" title=\"{$row['description']}\" style=\"border:1px solid #CCCCCC;\"" . XHTML . ">",
            'selected'      =>  ($current_lblock == $row['id'] ? ' checked="checked"' : '' ),
            'id'            =>  $row['id'],
            'name'          =>  $row['name'],
            'description'   =>  $row['description']
        ));
        $T->parse('ltblock','lblock',true);
    }

    $current_rblock = DB_getItem($_TABLES['cn_settings'],'rblock');
    $result = DB_query("SELECT * FROM {$_TABLES['cn_styles']} WHERE type='rblock'");
    $nRows  = DB_numRows($result);

    $T->set_block('admin', 'rblock','rtblock');

    for ( $i=0; $i < $nRows; $i++ ) {
        $row = DB_fetchArray($result);
        $T->set_var(array(
            'thumbnail'     =>  "<img src=\"{$_CONF['site_url']}/layout/chameleon/styles/rblock/{$row['id']}/block.gif\" alt=\"{$row['description']}\" title=\"{$row['description']}\" style=\"border:1px solid #CCCCCC;\"" . XHTML . ">",
            'selected'      =>  ($current_rblock == $row['id'] ? ' checked="checked"' : '' ),
            'id'            =>  $row['id'],
            'name'          =>  $row['name'],
            'description'   =>  $row['description']
        ));
        $T->parse('rtblock','rblock',true);
    }

    $current_menu_alignment = DB_getItem($_TABLES['cn_settings'],'menualign');
    if ( $current_menu_alignment == 0 ) {
        $T->set_var('rightselected',' checked="checked"');
        $T->set_var('leftselected','');
    } else {
        $T->set_var('rightselected','');
        $T->set_var('leftselected',' checked="checked"');
    }
    $T->set_var(array(
        'lang_menu_alignment'   =>  $LANG_CN01['menu_alignment'],
        'lang_right_align'      =>  $LANG_CN01['right_align'],
        'lang_left_align'       =>  $LANG_CN01['left_align'],
    ));

    $current_menu = DB_getItem($_TABLES['cn_settings'],'menu');
    $result = DB_query("SELECT * FROM {$_TABLES['cn_styles']} WHERE type='menu'");
    $nRows  = DB_numRows($result);

    $T->set_block('admin', 'menu','tmenu');

    for ( $i=0; $i < $nRows; $i++ ) {
        $row = DB_fetchArray($result);
        $T->set_var(array(
            'thumbnail'     =>  "<img src=\"{$_CONF['site_url']}/layout/chameleon/styles/menu/{$row['id']}/menu.gif\" alt=\"{$row['description']}\" title=\"{$row['description']}\" style=\"border:1px solid #CCCCCC;\"" . XHTML . ">",
            'selected'      =>  ($current_menu == $row['id'] ? ' checked="checked"' : '' ),
            'id'            =>  $row['id'],
            'name'          =>  $row['name'],
            'description'   =>  $row['description']
        ));
        $T->parse('tmenu','menu',true);
    }

    $current_logo = DB_getItem($_TABLES['cn_settings'],'logo');
    $current_slogan = DB_getItem($_TABLES['cn_settings'],'slogan');

    if ( $current_logo == 0 ) {
        $T->set_var('text_logo_selected',' checked="checked"');
    } else {
        $T->set_var('graphic_logo_selected',' checked="checked"');
    }
    if ( $current_slogan == 1 ) {
        $T->set_var('slogan_selected',' checked="checked"');
    }

    $T->parse('output', 'admin');
    $retval .= $T->finish($T->get_var('output'));
    return $retval;
}

function CN_saveSettings( ) {
    global $_CONF, $_TABLES,$LANG_CN01;

    $retval = '';

    $theme_layout   = isset($_POST['layout']) ? COM_applyFilter($_POST['layout'],true) : 1;
    $color_layout   = isset($_POST['color']) ? COM_applyFilter($_POST['color'],true) : 1;
    $lblock_layout  = isset($_POST['lblock']) ? COM_applyFilter($_POST['lblock'],true) : 1;
    $rblock_layout  = isset($_POST['rblock']) ? COM_applyFilter($_POST['rblock'],true) : 1;
    $menu_layout    = isset($_POST['menu'])  ? COM_applyFilter($_POST['menu'],true) : 1;
    $menu_align     = isset($_POST['menualign']) ? COM_applyFilter($_POST['menualign'],true) : 1;
    $logo           = isset($_POST['usegraphic']) ? COM_applyFilter($_POST['usegraphic'],true) : 0;
    $slogan         = isset($_POST['siteslogan']) ? COM_applyFilter($_POST['siteslogan'],true) : 0;

    if ( isset($_POST['manual']) ) {
        return CN_uploadStylePack();
    } else if ( isset($_POST['zip']) ) {
        return CN_uploadStylePack(true);
    }

    DB_query("UPDATE {$_TABLES['cn_settings']} SET layout=" . $theme_layout .
        ",color=" . $color_layout .
        ",lblock=" . $lblock_layout .
        ",rblock=" . $rblock_layout .
        ",menu=" . $menu_layout .
        ",menualign=" . $menu_align .
        ",logo=" . $logo .
        ",slogan=" . $slogan );

    $file = array();
    $file = $_FILES['newlogo'];
    if ( isset($file['tmp_name']) && $file['tmp_name'] != '' ) {
        $rc = move_uploaded_file($file['tmp_name'], $_CONF['path_themes'] . '/chameleon/styles/logo/logo.png');
        @chmod ($_CONF['path_themes'] . '/chameleon/styles/logo/logo.png', 0644);
    }

    $retval = chameleon_statusMessage($LANG_CN01['successful_save'],$_CONF['site_admin_url'] . '/plugins/chameleon/index.php','');
    return $retval;
}

function CN_editStyle($id) {
    global $_CONF, $_CN_CONF, $_TABLES, $_USER, $LANG_CN00, $LANG_CN01, $LANG_DIRECTION,$LANG04;

    $retval = '';
    $T = new Template($_CONF['path'] . 'plugins/chameleon/templates');
    $T->set_file ('admin','editstyle.thtml');
    $T->set_var('site_url', $_CONF['site_url']);
    $T->set_var('site_admin_url', $_CONF['site_admin_url']);
    $T->set_var('layout_url', $_CONF['layout_url']);
    $T->set_var('xhtml',XHTML);

    $result = DB_query("SELECT * FROM {$_TABLES['cn_styles']} WHERE id=" . $id);
    $numRows = DB_numRows($result);
    if ( $numRows < 1 ) {
        die("not found - FIX ME");
    }
    list($sid,$type,$name,$desc) = DB_fetchArray($result);

    $imgLocation = $type;
    if ( $type == 'lblock' || $type == 'rblock' ) {
        $imgLocation = 'block';
    }

    $T->set_var(array(
        'id'                        => $sid,
        'type'                      => $type,
        'name'                      => $name,
        'desc'                      => $desc,
        's_form_action'             => $_CONF['site_admin_url'] . '/plugins/chameleon/index.php',
        'thumbnail'                 => $_CONF['site_url'] . '/layout/' . '/chameleon/styles/' . $type . '/' . $sid . '/' . $imgLocation . '.gif',
        'lang_save'                 => $LANG_CN01['update'],
        'lang_cancel'               => $LANG_CN01['cancel'],
        'lang_reset'                => $LANG_CN01['reset'],
        'lang_id'                   => $LANG_CN01['id'],
        'lang_style_type'           => $LANG_CN01['style_type'],
        'lang_layout'               => $LANG_CN01['layout'],
        'lang_color'                => $LANG_CN01['color'],
        'lang_menu'                 => $LANG_CN01['menu'],
        'lang_lblock'               => $LANG_CN01['left_block'],
        'lang_rblock'               => $LANG_CN01['right_block'],
        'lang_name'                 => $LANG_CN01['name'],
        'lang_description'          => $LANG_CN01['description'],
        'lang_edit_style'           => $LANG_CN01['edit_style'],
        'lang_delete'               => $LANG_CN01['delete'],
        'lang_delete_confirm'       => $LANG_CN01['delete_confirm'],
    ));

    $T->parse('output', 'admin');
    $retval .= $T->finish($T->get_var('output'));
    return $retval;
}

function CN_saveStyleEdit( ) {
    global $_CONF, $_TABLES,$LANG_CN01;

    $id = COM_applyFilter($_POST['id'],true);

    $name = addslashes(COM_applyFilter($_POST['name']));
    $desc = addslashes(COM_applyFilter($_POST['desc']));

    DB_query("UPDATE {$_TABLES['cn_styles']} SET name='" . $name . "'" .
        ", description='" . $desc . "'" .
        " WHERE id=" . $id );

    $retval = chameleon_statusMessage($LANG_CN01['successful_save'],$_CONF['site_admin_url'] . '/plugins/chameleon/index.php','');

    return $retval;
}

function CN_deleteStyle($id) {
    global $_CONF, $_CN_CONF, $_TABLES, $_USER, $LANG_CN00, $LANG_CN01, $LANG_DIRECTION,$LANG04;

    $retval = '';

    $result = DB_query("SELECT * FROM {$_TABLES['cn_styles']} WHERE id=" . $id);
    $numRows = DB_numRows($result);
    if ( $numRows < 1 ) {
        die("not found (CN_deleteStyle) - FIX ME");
    }
    list($sid,$type,$name,$desc) = DB_fetchArray($result);

    if ( CN_deleteDir($_CONF['path_themes'] . 'chameleon/styles/' . $type . '/' . $sid) ) {
        DB_query("DELETE FROM {$_TABLES['cn_styles']} WHERE id=" . $id);
        $retval = chameleon_statusMessage($LANG_CN01['successful_delete'],$_CONF['site_admin_url'] . '/plugins/chameleon/index.php','');
    } else {
        $retval = chameleon_statusMessage($LANG_CN01['unsuccessful_delete'],$_CONF['site_admin_url'] . '/plugins/chameleon/index.php','');
    }
    return $retval;
}

function CN_deleteDir($dir) {
    if (substr($dir, strlen($dir)-1, 1) != '/')
        $dir .= '/';

    if ($handle = opendir($dir)) {
       while ($obj = readdir($handle)) {
           if ($obj != '.' && $obj != '..') {
               if (is_dir($dir.$obj)) {
                   if (!CN_deleteDir($dir.$obj))
                       return false;
               } elseif (is_file($dir.$obj)) {
                   if (!unlink($dir.$obj))
                       return false;
               }
           }
       }

       closedir($handle);

       if (!@rmdir($dir))
           return false;
       return true;
   }
   return false;
}

function CN_uploadStylePack($zip=false) {
    global $_CONF, $_TABLES, $LANG_CN01, $_CN_CONF;

    $retval = '';
    $T = new Template($_CONF['path'] . 'plugins/chameleon/templates');
    $T->set_file ('admin','addstyle.thtml');
    $T->set_var('site_url', $_CONF['site_url']);
    $T->set_var('site_admin_url', $_CONF['site_admin_url']);
    $T->set_var('layout_url', $_CONF['layout_url']);
    $T->set_var('xhtml',XHTML);

    $T->set_var('lang_success', $LANG_CN01['success']);
    $T->set_var('lang_continue', $LANG_CN01['continue']);
    $T->set_var('form_action', $_CONF['site_admin_url'].'/plugins/chameleon/index.php');

    $type = COM_applyFilter($_POST['stype']);
    $name = addslashes(COM_applyFilter($_POST['name']));
    $desc = addslashes(COM_applyFilter($_POST['desc']));

    $sql = "INSERT INTO {$_TABLES['cn_styles']} (`type`, `name`,`description`) " .
           "VALUES ('$type','$name','$desc');";
    DB_query($sql);
    $styleID = DB_insertId();

    $dir_custom_style = $_CONF['path_themes'] . '/chameleon/styles/' . $type . '/' . $styleID;
    @mkdir($dir_custom_style);
    @touch($dir_custom_style . '/index.html');

    if ($zip) {
        $file = array();
        $file = $_FILES['pack'];
        if ( isset($file['tmp_name']) && $file['tmp_name'] != '' ) {
            $status='';
            $results=array();
            $zip_path = $_CN_CONF['zip_path'];
            $tmpzip_path = $dir_custom_style . '/' . $type . '.zip';
            $rc = move_uploaded_file($file['tmp_name'], $tmpzip_path);
            if ( file_exists($zip_path) ) {
                $exdir = $dir_custom_style . '/';
                $cmd = '"'.$zip_path.'" -d '.$exdir.' '.$tmpzip_path;
                exec($cmd, $results, $status);
                if ( $status == 0 ) {
                } else {
                    COM_errorLog("failure! unzip. cmd[$cmd]",1);
                }
            } else {
                COM_errorLog("not found! zip path[$zip_path]",1);
            }
        } else {
            COM_errorLog("not file!",1);
        }
    } else {
        $T->set_var('lang_style_add', sprintf($LANG_CN01['style_add_database'],$styleID));
    }

    $lngtype = '';
    if ($type == 'layout') {
        $lngtype = $LANG_CN01['layout'];
    } else if ($type == 'menu') {
        $lngtype = $LANG_CN01['menu'];
    } else if ($type == 'lblock') {
        $lngtype = $LANG_CN01['left_block'];
    } else if ($type == 'rblock') {
        $lngtype = $LANG_CN01['right_block'];
    } else if ($type == 'color') {
        $lngtype = $LANG_CN01['color'];
    }
    $dir_style = $_CONF['path_themes'] . '/chameleon/styles/' . $type . '/' . $styleID;
    $T->set_var('lang_message', sprintf($LANG_CN01['manualcopy_style'],$lngtype,$dir_style));

    $T->parse('output', 'admin');
    $retval .= $T->finish($T->get_var('output'));
    return $retval;
}





/**
* Main
*/

$display = '';
$mode = '';
$msg = '';

if (isset ($_POST['mode'])) {
    $mode = COM_applyFilter($_POST['mode']);
} else if (isset ($_GET['mode'])) {
    $mode = COM_applyFilter($_GET['mode']);
} else {
    $mode = '';
}

if ( isset($_GET['msg']) ) {
    $msg = COM_applyFilter($_GET['msg']);
} else {
    $msg = '';
}

$display = COM_siteHeader('menu','');

if ( $msg != '' ) {
    echo COM_showMessage( $msg, 'chameleon' );
}

if ($mode == $LANG_CN01['save'] && !empty ($LANG_CN01['save'])) {   // save the config
    $display .= CN_saveSettings();
} elseif ($mode == $LANG_CN01['update'] && !empty ($LANG_CN01['update'])) {
    $display .= CN_saveStyleEdit();
} elseif ($mode == $LANG_CN01['cancel']) {
    echo COM_refresh ($_CONF['site_admin_url'] . '/plugins/chameleon/index.php');
    exit;
} elseif ( $mode == 'edit' ) {
    $id = COM_applyFilter($_GET['id'],true);
    $display .= CN_editStyle($id);
} elseif ($mode == $LANG_CN01['delete'] && !empty ($LANG_CN01['delete'])) {
    $id = COM_applyFilter($_POST['id'],true);
    $display .= CN_deleteStyle($id);
} else {
    $display .= CN_editSettings();
}
$display .= COM_siteFooter();
echo $display;
exit;
?>