<?php
// +---------------------------------------------------------------------------+
// | Theme Functions                                                           |
// +---------------------------------------------------------------------------+
// | $Id:: functions.php 1717 2007-12-17 03:56:42Z mevans0263                 $|
// +---------------------------------------------------------------------------+
// | Copyright (C) 2007 by the following authors:                              |
// |                                                                           |
// | Author:                                                                   |
// | Mark R. Evans              - mevans@ecsnet.com                            |
// |  based on original COM_siteHeader() and COM_siteFooter() Geeklog functions|
// +---------------------------------------------------------------------------+
// | LICENSE                                                                   |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+


// this file can't be used on its own
if (strpos(strtolower($_SERVER['PHP_SELF']), 'functions.php') !== false) {
    die ('This file can not be used on its own!');
}

$_IMAGE_TYPE = 'png';

if (!defined ('XHTML')) {
    define('XHTML',''); // change this to ' /' for XHTML
}

$result = DB_query ("SELECT onleft,name,title FROM {$_TABLES['blocks']}");

$nrows = DB_numRows ($result);
for ($i = 0; $i < $nrows; $i++) {
    $A = DB_fetchArray ($result);
    if ($A['onleft'] == 1) {
        if ( strncasecmp($A['title'],".",1) == 0){
            $_BLOCK_TEMPLATE[$A['name']] = 'blockheader-left-notitle.thtml,blockfooter-left.thtml';
        } else {
            $_BLOCK_TEMPLATE[$A['name']] = 'blockheader-left.thtml,blockfooter-left.thtml';
        }
    } else {
        if ( strncasecmp($A['title'],".",1) == 0){
            $_BLOCK_TEMPLATE[$A['name']] = 'blockheader-right-notitle.thtml,blockfooter-right.thtml';
        } else {
            $_BLOCK_TEMPLATE[$A['name']] = 'blockheader-right.thtml,blockfooter-right.thtml';
        }
    }
}

$_BLOCK_TEMPLATE['_msg_block'] = 'blockheader-message.thtml,blockfooter-message.thtml';
$_BLOCK_TEMPLATE['configmanager_block'] = 'blockheader-config.thtml,blockfooter-config.thtml';
$_BLOCK_TEMPLATE['configmanager_subblock'] = 'blockheader-config.thtml,blockfooter-config.thtml';
$_BLOCK_TEMPLATE['whats_related_block'] = 'blockheader-related.thtml,blockfooter-related.thtml';
$_BLOCK_TEMPLATE['story_options_block'] = 'blockheader-related.thtml,blockfooter-related.thtml';

// Define the blocks that are a list of links styled as an unordered list - using class="blocklist"
$_BLOCK_TEMPLATE['admin_block'] = 'blockheader-list.thtml,blockfooter-list.thtml';
$_BLOCK_TEMPLATE['section_block'] = 'blockheader-list.thtml,blockfooter-list.thtml';
if (!COM_isAnonUser()) {
    $_BLOCK_TEMPLATE['user_block'] = 'blockheader-list.thtml,blockfooter-list.thtml';
}

/********************* FORUM PLUGIN v2.7+ Setup for block layout to use ********************
* Fourm Plugin for Geeklog v1.4.1 available at http://www.portalparts.com
* Set the following for which Geeklog block columns you want to show along with the forum.
* Options are: 'leftblocks', 'rightblocks', 'allblocks', 'noblocks'
* For example, set to noblocks to not show any blocks (and have the forum span the entire page.)
***************************************************************************************/
$CONF_FORUM['showblocks'] = 'leftblocks';

/********************* FORUM PLUGIN v2.7+  Setup for user menu style to use ****************
* Show the usermenu as a block menu or as a top navbar
* Note: Need to show leftblocks or rightblocks if usermenu option set to blockmenu
* Options are 'blockmenu' or 'navbar' or 'none'
***************************************************************************************/
$CONF_FORUM['usermenu'] = 'navbar';


/**
* Returns the site header
*
* This loads the proper templates, does variable substitution and returns the
* HTML for the site header with or without blocks depending on the value of $what
*
* Note that the default for the header is to display the left blocks and the
* default of the footer is to not display the right blocks.
*
* @param    string  $what       If 'none' then no left blocks are returned, if 'menu' (default) then right blocks are returned
* @param    string  $pagetitle  optional content for the page's <title>
* @param    string  $headercode optional code to go into the page's <head>
* @return   string              Formatted HTML containing the site header
* @see function COM_siteFooter
*
*/

function chameleon_siteHeader($what = 'menu', $pagetitle = '', $headercode = '' )
{
    global $_CONF, $_TABLES, $_USER, $LANG01, $LANG_BUTTONS, $LANG_DIRECTION, $LANG_CN01,
           $_IMAGE_TYPE, $topic, $_COM_VERBOSE, $theme_what, $theme_pagetitle,
           $theme_headercode, $theme_layout;

    $theme_what         = $what;
    $theme_pagetitle    = $pagetitle;
    $theme_headercode   = $headercode;

    // determine which layout we're using:

    if ( !function_exists('plugin_chkVersion_chameleon') ) {
        $theme_layout = 1;
        $color_layout = 36;
        $lblock_layout = 30;
        $rblock_layout = 33;
        $menu_layout = 21;
        $menu_align = 1;
        $logo = 1;
        $slogan = 0;
    } else {
        $result = DB_query("SELECT * FROM {$_TABLES['cn_settings']}");
        list($theme_layout,$color_layout,$lblock_layout,$rblock_layout,$menu_layout,$menu_align,$logo_type,$use_slogan) = DB_fetchArray($result);
    }

    if ( empty($theme_layout) || $theme_layout == '' || $theme_layout == 0 ) {
        $theme_layout = 1;
    }

    // send out the charset header
    header( 'Content-Type: text/html; charset=' . COM_getCharset());

    $header = new Template( $_CONF['path_layout'] );
    $header->set_file( array(
        'header'        => 'htmlheader.thtml',
    ));
    $header->set_var('xhtml',XHTML);
    $header->set_var('skip_navigation',$LANG_CN01['skip_navigation']);

    // get topic if not on home page
    if( !isset( $_GET['topic'] ))
    {
        if( isset( $_GET['story'] ))
        {
            $sid = COM_applyFilter( $_GET['story'] );
        }
        elseif( isset( $_GET['sid'] ))
        {
            $sid = COM_applyFilter( $_GET['sid'] );
        }
        elseif( isset( $_POST['story'] ))
        {
            $sid = COM_applyFilter( $_POST['story'] );
        }
        if( empty( $sid ) && $_CONF['url_rewrite'] &&
                ( strpos( $_SERVER['PHP_SELF'], 'article.php' ) !== false ))
        {
            COM_setArgNames( array( 'story', 'mode' ));
            $sid = COM_applyFilter( COM_getArgument( 'story' ));
        }
        if( !empty( $sid ))
        {
            $topic = DB_getItem( $_TABLES['stories'], 'tid', "sid='$sid'" );
        }
    }
    else
    {
        $topic = COM_applyFilter( $_GET['topic'] );
    }

    $feed_url = array();
    if( $_CONF['backend'] == 1 ) // add feed-link to header if applicable
    {
        $baseurl = SYND_getFeedUrl();

        $sql = 'SELECT format, filename, title, language FROM '
             . $_TABLES['syndication'] . " WHERE (header_tid = 'all')";
        if( !empty( $topic ))
        {
            $sql .= " OR (header_tid = '" . addslashes( $topic ) . "')";
        }
        $result = DB_query( $sql );
        $numRows = DB_numRows( $result );
        for( $i = 0; $i < $numRows; $i++ )
        {
            $A = DB_fetchArray( $result );
            if ( !empty( $A['filename'] ))
            {
                $format = explode( '-', $A['format'] );
                $format_type = strtolower( $format[0] );
                $format_name = ucwords( $format[0] );

                $feed_url[] = '<link rel="alternate" type="application/'
                          . $format_type . '+xml" hreflang="' . $A['language']
                          . '" href="' . $baseurl . $A['filename'] . '" title="'
                          . $format_name . ' Feed: ' . $A['title'] . '"' . XHTML . '>';
            }
        }
    }
    $header->set_var( 'feed_url', implode( LB, $feed_url ));

    $relLinks = array();
    if( !COM_onFrontpage() )
    {
        $relLinks['home'] = '<link rel="home" href="' . $_CONF['site_url']
                          . '/" title="' . $LANG01[90] . '"' . XHTML . '>';
    }
    $loggedInUser = !COM_isAnonUser();
    if( $loggedInUser || (( $_CONF['loginrequired'] == 0 ) &&
                ( $_CONF['searchloginrequired'] == 0 )))
    {
        if(( substr( $_SERVER['PHP_SELF'], -strlen( '/search.php' ))
                != '/search.php' ) || isset( $_GET['mode'] ))
        {
            $relLinks['search'] = '<link rel="search" href="'
                                . $_CONF['site_url'] . '/search.php" title="'
                                . $LANG01[75] . '"' . XHTML . '>';
        }
    }
    if( $loggedInUser || (( $_CONF['loginrequired'] == 0 ) &&
                ( $_CONF['directoryloginrequired'] == 0 )))
    {
        if( strpos( $_SERVER['PHP_SELF'], '/article.php' ) !== false ) {
            $relLinks['contents'] = '<link rel="contents" href="'
                        . $_CONF['site_url'] . '/directory.php" title="'
                        . $LANG01[117] . '"' . XHTML . '>';
        }
    }
    if (!$_CONF['disable_webservices']) {
        $relLinks['service'] = '<link rel="service" '
                    . 'type="application/atomsvc+xml" ' . 'href="'
                    . $_CONF['site_url'] . '/webservices/atom/?introspection" '
                    . 'title="' . $LANG01[130] . '"' . XHTML . '>';
    }

    $header->set_var( 'rel_links', implode( LB, $relLinks ));

    if( empty( $pagetitle ) && isset( $_CONF['pagetitle'] ))
    {
        $pagetitle = $_CONF['pagetitle'];
    }
    if( empty( $pagetitle ))
    {
        if( empty( $topic ))
        {
            $pagetitle = $_CONF['site_slogan'];
        }
        else
        {
            $pagetitle = DB_getItem( $_TABLES['topics'], 'topic',
                                                   "tid = '$topic'" );
        }
    }
    if( !empty( $pagetitle ))
    {
        $header->set_var( 'page_site_splitter', ' - ');
    }
    else
    {
        $header->set_var( 'page_site_splitter', '');
    }
    $header->set_var( 'page_title', $pagetitle );
    $header->set_var( 'site_name', $_CONF['site_name']);

    if (COM_onFrontpage()) {
        $title_and_name = $_CONF['site_name'];
        if (!empty($pagetitle)) {
            $title_and_name .= ' - ' . $pagetitle;
        }
    } else {
        $title_and_name = '';
        if (!empty($pagetitle)) {
            $title_and_name = $pagetitle . ' - ';
        }
        $title_and_name .= $_CONF['site_name'];
    }
    $header->set_var('page_title_and_site_name', $title_and_name);

    if( isset( $_CONF['advanced_editor'] ) && ( $_CONF['advanced_editor'] == 1 )
            && file_exists( $_CONF['path_layout']
                            . 'advanced_editor_header.thtml' ))
    {
        $header->set_file( 'editor'  , 'advanced_editor_header.thtml');
        $header->set_var('xthml',XHTML);
        $header->parse( 'advanced_editor', 'editor' );

    }
    else
    {
        $header->set_var( 'xhtml', XHTML );
        $header->set_var( 'advanced_editor', '' );
    }

    $langAttr = '';
    if( !empty( $_CONF['languages'] ) && !empty( $_CONF['language_files'] ))
    {
        $langId = COM_getLanguageId();
    }
    else
    {
        // try to derive the language id from the locale
        $l = explode( '.', $_CONF['locale'] );
        $langId = $l[0];
    }
    if( !empty( $langId ))
    {
        $l = explode( '-', str_replace( '_', '-', $langId ));
        if(( count( $l ) == 1 ) && ( strlen( $langId ) == 2 ))
        {
            $langAttr = 'lang="' . $langId . '"';
        }
        else if( count( $l ) == 2 )
        {
            if(( $l[0] == 'i' ) || ( $l[0] == 'x' ))
            {
                $langId = implode( '-', $l );
                $langAttr = 'lang="' . $langId . '"';
            }
            else if( strlen( $l[0] ) == 2 )
            {
                $langId = implode( '-', $l );
                $langAttr = 'lang="' . $langId . '"';
            }
            else
            {
                $langId = $l[0];
            }
        }
    }
    $header->set_var( 'lang_id', $langId );
    if (!empty($_CONF['languages']) && !empty($_CONF['language_files'])) {
        $header->set_var('lang_attribute', $langAttr);
    } else {
        $header->set_var('lang_attribute', '');
    }

    $header->set_var( 'background_image', $_CONF['layout_url']
                                          . '/images/bg.' . $_IMAGE_TYPE );
    $header->set_var( 'site_url', $_CONF['site_url'] );
    $header->set_var( 'site_admin_url', $_CONF['site_admin_url'] );
    $header->set_var( 'layout_url', $_CONF['layout_url'] );
    $header->set_var( 'site_mail', "mailto:{$_CONF['site_mail']}" );
    $header->set_var( 'site_name', $_CONF['site_name'] );
    $header->set_var( 'site_slogan', $_CONF['site_slogan'] );
    $rdf = substr_replace( $_CONF['rdf_file'], $_CONF['site_url'], 0,
                           strlen( $_CONF['path_html'] ) - 1 );
    $header->set_var( 'rdf_file', $rdf );
    $header->set_var( 'rss_url', $rdf );

    $layout_url = $_CONF['layout_url'] . '/styles/layout/' . $theme_layout  . '/layout.css';
    $menu_url   = $_CONF['layout_url'] . '/styles/menu/'   . $menu_layout   . '/menu.css';
    $lblock_url = $_CONF['layout_url'] . '/styles/lblock/' . $lblock_layout . '/block.css';
    $rblock_url = $_CONF['layout_url'] . '/styles/rblock/' . $rblock_layout . '/block.css';
    $color_url  = $_CONF['layout_url'] . '/styles/color/'  . $color_layout  . '/color.css';
    if ( $menu_align == 1 ) {
        $menu_align_url = $_CONF['layout_url'] . '/styles/menu/menuleft.css';
    } else {
        $menu_align_url = $_CONF['layout_url'] . '/styles/menu/menuright.css';
    }

    $header->set_var( 'css_url', $_CONF['layout_url'] . '/style.css');
    $header->set_var( 'theme_layout_url', $layout_url );
    $header->set_var( 'theme_menu_url', $menu_url );
    $header->set_var( 'theme_lblock_url', $lblock_url );
    $header->set_var( 'theme_rblock_url', $rblock_url );
    $header->set_var( 'theme_color_url', $color_url );
    $header->set_var( 'menu_align_url', $menu_align_url );

    $header->set_var( 'theme', $_CONF['theme'] );

    $header->set_var( 'charset', COM_getCharset());
    if( empty( $LANG_DIRECTION ))
    {
        // default to left-to-right
        $header->set_var( 'direction', 'ltr' );
    }
    else
    {
        $header->set_var( 'direction', $LANG_DIRECTION );
    }

    // Call any plugin that may want to include extra Meta tags
    // or Javascript functions
    $header->set_var( 'plg_headercode', $headercode . PLG_getHeaderCode() );

    // Call to plugins to set template variables in the header
    PLG_templateSetVars( 'header', $header );

    $tmp = $header->parse( 'index_header', 'header' );
    $retval = eval( '?>' . $tmp );

    // Start caching / capturing output from Geeklog / plugins

    ob_start();

    return $retval;
}

/**
* Returns the site footer
*
* This loads the proper templates, does variable substitution and returns the
* HTML for the site footer.
*
* @param   boolean     $rightblock     Whether or not to show blocks on right hand side default is no
* @param   array       $custom         An array defining custom function to be used to format Rightblocks
* @see function themename_siteHeader
* @return   string  Formated HTML containing site footer and optionally right blocks
*
*/
function chameleon_siteFooter( $rightblock = -1, $custom = '' )
{
    global $_CONF, $_TABLES, $_USER, $LANG01, $LANG12, $LANG_BUTTONS, $LANG_DIRECTION, $LANG_CN01,
           $_IMAGE_TYPE, $topic, $_COM_VERBOSE, $_PAGE_TIMER, $theme_what,
           $theme_pagetitle, $theme_headercode, $theme_layout;

    $what       = $theme_what;
    $pagetitle  = $theme_pagetitle;
    $themecode  = $theme_headercode;

    if ( !function_exists('plugin_chkVersion_chameleon') ) {
        $theme_layout = 1;
        $color_layout = 36;
        $lblock_layout = 30;
        $rblock_layout = 33;
        $menu_layout = 21;
        $menu_align = 1;
        $logo = 1;
        $slogan = 0;
    } else {
        $result = DB_query("SELECT * FROM {$_TABLES['cn_settings']}");
        list($theme_layout,$color_layout,$lblock_layout,$rblock_layout,$menu_layout,$menu_align,$logo_type,$use_slogan) = DB_fetchArray($result);
    }


    // Grab any content that was cached by the system

    $content = ob_get_contents();
    ob_end_clean();

    $theme = new Template( $_CONF['path_layout'] );
    $theme->set_file( array(
        'header'        => 'header.thtml',
        'footer'        => 'footer.thtml',
        'menuitem'      => 'menuitem.thtml',
        'menuitem_last' => 'menuitem_last.thtml',
        'menuitem_none' => 'menuitem_none.thtml',
        'leftblocks'    => 'leftblocks.thtml',
        'rightblocks'   => 'rightblocks.thtml',
    ));
    $theme->set_var('xhtml',XHTML);
    $theme->set_var('jump_pagetop',$LANG_CN01['jump_pagetop']);

    // get topic if not on home page
    if( !isset( $_GET['topic'] ))
    {
        if( isset( $_GET['story'] ))
        {
            $sid = COM_applyFilter( $_GET['story'] );
        }
        elseif( isset( $_GET['sid'] ))
        {
            $sid = COM_applyFilter( $_GET['sid'] );
        }
        elseif( isset( $_POST['story'] ))
        {
            $sid = COM_applyFilter( $_POST['story'] );
        }
        if( empty( $sid ) && $_CONF['url_rewrite'] &&
                ( strpos( $_SERVER['PHP_SELF'], 'article.php' ) !== false ))
        {
            COM_setArgNames( array( 'story', 'mode' ));
            $sid = COM_applyFilter( COM_getArgument( 'story' ));
        }
        if( !empty( $sid ))
        {
            $topic = DB_getItem( $_TABLES['stories'], 'tid', "sid='$sid'" );
        }
    }
    else
    {
        $topic = COM_applyFilter( $_GET['topic'] );
    }

    $loggedInUser = !COM_isAnonUser();
    if( $loggedInUser || (( $_CONF['loginrequired'] == 0 ) &&
                ( $_CONF['searchloginrequired'] == 0 )))
    {
        if(( substr( $_SERVER['PHP_SELF'], -strlen( '/search.php' ))
                != '/search.php' ) || isset( $_GET['mode'] ))
        {
            $relLinks['search'] = '<link rel="search" href="'
                                . $_CONF['site_url'] . '/search.php" title="'
                                . $LANG01[75] . '"' . XHTML . '>';
        }
    }
    if( $loggedInUser || (( $_CONF['loginrequired'] == 0 ) &&
                ( $_CONF['directoryloginrequired'] == 0 )))
    {
        if( strpos( $_SERVER['PHP_SELF'], '/article.php' ) !== false ) {
            $relLinks['contents'] = '<link rel="contents" href="'
                        . $_CONF['site_url'] . '/directory.php" title="'
                        . $LANG01[117] . '"' . XHTML . '>';
        }
    }
    $theme->set_var( 'site_name', $_CONF['site_name']);
    $theme->set_var( 'background_image', $_CONF['layout_url']
                                          . '/images/bg.' . $_IMAGE_TYPE );
    $theme->set_var( 'site_url', $_CONF['site_url'] );
    $theme->set_var( 'layout_url', $_CONF['layout_url'] );
    $theme->set_var( 'site_mail', "mailto:{$_CONF['site_mail']}" );
    $theme->set_var( 'site_name', $_CONF['site_name'] );
    if ($use_slogan) {
        $theme->set_var( 'site_slogan', $_CONF['site_slogan'] );
    }

    $msg = $LANG01[67] . ' ' . $_CONF['site_name'];

    if( !empty( $_USER['username'] ))
    {
        $msg .= ', ' . COM_getDisplayName( $_USER['uid'], $_USER['username'],
                                           $_USER['fullname'] );
    }

    $curtime =  COM_getUserDateTimeFormat();

    $theme->set_var( 'welcome_msg', $msg );
    $theme->set_var( 'datetime', $curtime[0] );

    if ( $logo_type == 1 ) {
        $L = new Template( $_CONF['path_layout'] );
        $L->set_file( array(
            'logo'          => 'logo-graphic.thtml',
        ));
        $L->set_var( 'xhtml', XHTML);
        $L->set_var( 'site_url', $_CONF['site_url'] );
        $L->set_var( 'layout_url', $_CONF['layout_url'] );
        $L->set_var( 'site_name', $_CONF['site_name'] );
        if ( file_exists($_CONF['path_layout'] . '/styles/logo/logo.png') ) {
            $site_logo = $_CONF['layout_url'] . '/styles/logo/logo.png';
        } else {
            $site_logo = $_CONF['layout_url'] . '/images/logo.' . $_IMAGE_TYPE;
        }
        $L->set_var( 'site_logo', $site_logo);
        if ($use_slogan) {
            $L->set_var( 'site_slogan', $_CONF['site_slogan'] );
        }
        $L->parse('output','logo');
        $theme->set_var('logo_block',$L->finish($L->get_var('output')));
    } else {
        $L = new Template( $_CONF['path_layout'] );
        $L->set_file( array(
            'logo'          => 'logo-text.thtml',
        ));
        $L->set_var( 'xhtml',XHTML);
        $L->set_var( 'site_name', $_CONF['site_name'] );
        $L->set_var( 'site_url', $_CONF['site_url'] );
        $L->set_var( 'layout_url', $_CONF['layout_url'] );

        if ($use_slogan) {
            $L->set_var( 'site_slogan', $_CONF['site_slogan'] );
        }

        $L->parse('output','logo');
        $theme->set_var('logo_block',$L->finish($L->get_var('output')));
    }


    $theme->set_var( 'site_logo', $_CONF['layout_url']
                                   . '/images/logo.' . $_IMAGE_TYPE );

    $theme->set_var( 'charset', COM_getCharset());

    // Now add variables for buttons like e.g. those used by the Yahoo theme
    $theme->set_var( 'button_home', $LANG_BUTTONS[1] );
    $theme->set_var( 'button_contact', $LANG_BUTTONS[2] );
    $theme->set_var( 'button_contribute', $LANG_BUTTONS[3] );
    $theme->set_var( 'button_sitestats', $LANG_BUTTONS[7] );
    $theme->set_var( 'button_personalize', $LANG_BUTTONS[8] );
    $theme->set_var( 'button_search', $LANG_BUTTONS[9] );
    $theme->set_var( 'button_advsearch', $LANG_BUTTONS[10] );
    $theme->set_var( 'button_directory', $LANG_BUTTONS[11] );

    $theme->set_var( array (
        'lang_login'    => $LANG01[58],
        'lang_myaccount'    => $LANG01[48],
        'lang_logout'       => $LANG01[35],
        'lang_newuser'      => $LANG12[3],
    ));

    // Get plugin menu options
    $plugin_menu = PLG_getMenuItems();

    if( $_COM_VERBOSE )
    {
        COM_errorLog( 'num plugin menu items in header = ' . count( $plugin_menu ), 1 );
    }

    // Now add nested template for menu items
    COM_renderMenu( $theme, $plugin_menu );

    if( count( $plugin_menu ) == 0 )
    {
        $theme->parse( 'plg_menu_elements', 'menuitem_none', true );
    }
    else
    {
        $count_plugin_menu = count( $plugin_menu );
        for( $i = 1; $i <= $count_plugin_menu; $i++ )
        {
            $theme->set_var( 'menuitem_url', current( $plugin_menu ));
            $theme->set_var( 'menuitem_text', key( $plugin_menu ));

            if( $i == $count_plugin_menu )
            {
                $theme->parse( 'plg_menu_elements', 'menuitem_last', true );
            }
            else
            {
                $theme->parse( 'plg_menu_elements', 'menuitem', true );
            }

            next( $plugin_menu );
        }
    }

    $lblocks = '';

    /* Check if an array has been passed that includes the name of a plugin
     * function or custom function
     * This can be used to take control over what blocks are then displayed
     */
    if( is_array( $what ))
    {
        $function = $what[0];
        if( function_exists( $function ))
        {
            $lblocks = $function( $what[1], 'left' );
        }
        else
        {
            $lblocks = COM_showBlocks( 'left', $topic );
        }
    }
    else if( $what <> 'none' )
    {
        // Now show any blocks -- need to get the topic if not on home page
        $lblocks = COM_showBlocks( 'left', $topic );
    }

    /* Now build footer */

    if( empty( $lblocks ))
    {
        $theme->set_var( 'left_blocks', '' );
        $theme->set_var( 'geeklog_blocks', '' );
    }
    else
    {
        $theme->set_var( 'geeklog_blocks', $lblocks );
    }

    // Do variable assignments
    DB_change( $_TABLES['vars'], 'value', 'value + 1', 'name', 'totalhits', '', true );

    $theme->set_var( 'site_url', $_CONF['site_url']);
    $theme->set_var( 'site_mail', "mailto:{$_CONF['site_mail']}" );
    $theme->set_var( 'site_name', $_CONF['site_name'] );
    $theme->set_var( 'site_slogan', $_CONF['site_slogan'] );
    $rdf = substr_replace( $_CONF['rdf_file'], $_CONF['site_url'], 0,
                          strlen( $_CONF['path_html'] ) - 1 );
    $theme->set_var( 'rdf_file', $rdf );
    $theme->set_var( 'rss_url', $rdf );

    $year = date( 'Y' );
    $copyrightyear = $year;
    if( !empty( $_CONF['copyrightyear'] ))
    {
        $copyrightyear = $_CONF['copyrightyear'];
    }
    $theme->set_var( 'copyright_notice', '&nbsp;' . $LANG01[93] . ' &copy; '
            . $copyrightyear . ' ' . $_CONF['site_name'] . '<br' . XHTML . '>&nbsp;'
            . $LANG01[94] );
    $theme->set_var( 'copyright_msg', $LANG01[93] . ' &copy; '
            . $copyrightyear . ' ' . $_CONF['site_name'] );
    $theme->set_var( 'current_year', $year );
    $theme->set_var( 'lang_copyright', $LANG01[93] );
    $theme->set_var( 'trademark_msg', $LANG01[94] );
    $theme->set_var( 'powered_by', $LANG01[95] );
    $theme->set_var( 'geeklog_url', 'http://www.geeklog.net/' );
    $theme->set_var( 'geeklog_version', VERSION );

    /* Check if an array has been passed that includes the name of a plugin
     * function or custom function.
     * This can be used to take control over what blocks are then displayed
     */
    if( is_array( $custom ))
    {
        $function = $custom['0'];
        if( function_exists( $function ))
        {
            $rblocks = $function( $custom['1'], 'right' );
        }
    }
    elseif( $rightblock == 1 )
    {
        $rblocks = '';

        $rblocks = COM_showBlocks( 'right', $topic );

        if( empty( $rblocks ))
        {
            $theme->set_var( 'geeklog_rblocks', '');
            $theme->set_var( 'right_blocks','');
        }
        else
        {
            $theme->set_var( 'geeklog_rblocks', $rblocks);
        }
    } else {
        $theme->set_var( 'geeklog_rblocks', '');
        $theme->set_var( 'right_blocks', '' );
    }

    $flg_renderLayout = false;
    $path_style_layout = $_CONF['path_themes'] . '/chameleon/styles/layout/' . $theme_layout . '/layout.php';
    if ( file_exists($path_style_layout) ) {
        require_once($path_style_layout);
        if ( function_exists('chameleon_renderLayout') ) {
            chameleon_renderLayout($theme, $lblocks, $rblocks);
            $flg_renderLayout = true;
        }
    }
    if ( !$flg_renderLayout ) {
        $theme->set_var('gl_extra','gl_extra');
        $theme->set_var('gl_navigation','gl_navigation');
        if ( empty($lblocks) && empty($rblocks) ) {
            $theme->set_var('gl_content','gl_content-full');
        } else if ( empty($lblocks) ) {
            $theme->set_var('gl_content','gl_content-wide-right');
        } else if ( empty($rblocks)) {
            $theme->set_var('gl_content','gl_content-wide-left');
        } else {
            $theme->set_var('gl_content','gl_content');
        }
    }
    if ( !empty( $lblocks) ) {
        $theme->parse( 'left_blocks', 'leftblocks', true );
        $theme->set_var( 'geeklog_blocks', '');
    }
    if ( !empty ($rblocks) ) {
        $theme->parse( 'right_blocks', 'rightblocks', true );
        $theme->set_var( 'geeklog_rblocks', '');
    }

    $exectime = $_PAGE_TIMER->stopTimer();
    $exectext = $LANG01[91] . ' ' . $exectime . ' ' . $LANG01[92];

    $theme->set_var( 'execution_time', $exectime );
    $theme->set_var( 'execution_textandtime', $exectext );

    $theme->set_var('content',$content);

    // Call to plugins to set template variables in the footer
    PLG_templateSetVars( 'header', $theme );
    PLG_templateSetVars( 'footer', $theme );

    // Actually parse the template and make variable substitutions
    $theme->parse( 'index_footer', 'footer' );

    // The following lines allow users to embed PHP in their templates.  This
    // is almost a contradition to the reasons for using templates but this may
    // prove useful at times ...
    // Don't use PHP in templates if you can live without it!

    $tmp = $theme->parse( 'index_header', 'header' );
    $retval = eval( '?>' . $tmp );

    $retval .= $theme->finish( $theme->get_var( 'index_footer' ));
    return $retval;
}


/**
* Get the current character set
*
* @return   string      character set, e.g. 'utf-8'
*
* Uses (if available, and in this order)
* - $LANG_CHARSET (from the current language file)
* - $_CONF['default_charset'] (from config.php)
* - 'iso-8859-1' (hard-coded fallback)
*
*/
if ( !function_exists('COM_getCharset') ) {
    function COM_getCharset()
    {
        global $_CONF, $LANG_CHARSET;

        if( empty( $LANG_CHARSET )) {
            $charset = $_CONF['default_charset'];
            if( empty( $charset )) {
                $charset = 'iso-8859-1';
            }
        } else {
            $charset = $LANG_CHARSET;
        }

        return $charset;
    }
}

/**
  * Checks to see if a specified user, or the current user if non-specified
  * is the anonymous user.
  *
  * @param  int $uid    ID of the user to check, or none for the current user.
  * @return boolean     true if the user is the anonymous user.
  */
if ( !function_exists('COM_isAnonUser') ) {
    function COM_isAnonUser($uid = '')
    {
        global $_USER;

        /* If no user was specified, fail over to the current user if there is one */
        if( empty( $uid ) )
        {
            if( isset( $_USER['uid'] ) )
            {
                $uid = $_USER['uid'];
            }
        }

        if( !empty( $uid ) )
        {
            return ($uid == 1);
        } else {
            return true;
        }
    }
}
?>